%% combining info from two neurons
load datasetCombine1

% calculate means and standard deviations for all combinations of the two
% neurons and two directions of movement
muLeft1=mean(neuron1Left);
muRight1=mean(neuron1Right);
stdLeft1=std(neuron1Left);
stdRight1=std(neuron1Right);
muLeft2=mean(neuron2Left);
muRight2=mean(neuron2Right);
stdLeft2=std(neuron2Left);
stdRight2=std(neuron2Right);

% calculate the probabilities of the spikes given the assumed direction for
% each of the two neurons
pN1gLeft=1/(sqrt(2*pi)*stdLeft1)*exp(-(testSet1-muLeft1).^2/(2*stdLeft1^2));
pN1gRight=1/(sqrt(2*pi)*stdRight1)*exp(-(testSet1-muRight1).^2/(2*stdRight1^2));
pN2gLeft=1/(sqrt(2*pi)*stdLeft2)*exp(-(testSet2-muLeft2).^2/(2*stdLeft2^2));
pN2gRight=1/(sqrt(2*pi)*stdRight2)*exp(-(testSet2-muRight2).^2/(2*stdRight2^2));

% Use Bayes rule to calculate the probability of moving left in the two
% cases
pLeft1=pN1gLeft./(pN1gLeft+pN1gRight);  % here we are using Bayes rule
pLeft2=pN2gLeft./(pN2gLeft+pN2gRight);  % here we are using Bayes rule

% Combine the two using Bayes rule again
pLeft=pLeft1.*pLeft2./(pLeft1.*pLeft2+(1-pLeft1).*(1-pLeft2));
plot(pLeft)
hold on
plot(pLeft1,'r')
plot(pLeft2,'g')
hold off
