clear all
%simulate two experimental situations
neuronLeft=2+0.5*randn(100000,1);
neuronRight=1.5+0.5*randn(100000,1);

%divide the stuff into test set and training set.
testSet=[neuronLeft(99900:end) ;neuronRight(99900:end)];
neuronLeft=neuronLeft(1:89999);
neuronRight=neuronRight(1:89999);
save datasetStart
%% another dataset to see what happens if 
clear all
neuronLeft=2.5+0.5*randn(100000,1);
neuronRight=1.5+0.5*randn(100000,1);
%divide the stuff into test set and training set.
testSet=[neuronLeft(99900:end) ;neuronRight(99900:end)];
neuronLeft=neuronLeft(1:89999);
neuronRight=neuronRight(1:89999);
save datasetStart2
%% a dataset to combine info from two neurons
clear all
neuron1Left=2.5+0.5*randn(1000,1);
neuron1Right=1.5+0.5*randn(1000,1);
neuron2Left=2+0.5*randn(1000,1);
neuron2Right=3+0.5*randn(1000,1);
%divide the stuff into test set and training set.
testSet1=[neuron1Left(900:end);neuron1Right(900:end)];
testSet2=[neuron2Left(900:end);neuron2Right(900:end)];
neuron1Left=neuron1Left(1:899);
neuron1Right=neuron1Right(1:899);
neuron2Left=neuron2Left(1:899);
neuron2Right=neuron2Right(1:899);

save datasetCombine1

%% steps leading up to probability
load datasetStart
x=-1:.1:5
hist(neuronLeft,x);
figure
hist(neuronRight,x);
histRight=hist(neuronRight,x);
histLeft=hist(neuronLeft,x);
hist([neuronLeft neuronRight],x)
pLeft=histLeft./(histLeft+histRight); %bayes rule
pRight=histRight./(histLeft+histRight);
plot(x,pLeft)
%% get the probability for each stimulus
muLeft=mean(neuronLeft);
muRight=mean(neuronRight);
stdLeft=std(neuronLeft);
stdRight=std(neuronRight);
pNgLeft=1/(sqrt(2*pi)*stdLeft)*exp(-(testSet-muLeft).^2/(2*stdLeft^2));
pNgRight=1/(sqrt(2*pi)*stdRight)*exp(-(testSet-muRight).^2/(2*stdRight^2));
pLeft=pNgLeft./(pNgLeft+pNgRight);  % here we are using Bayes rule
figure(1)
plot(testSet,pLeft,'.');
figure(2)
plot(pLeft);

%% how good
pEq=min(testSet(find(pLeft>.5)));
falseNegative=sum(neuronLeft<pEq)/length(neuronLeft) %switch to test set
falsePositive=sum(neuronRight>pEq)/length(neuronLeft)

% do the same thing with a different simulated neurons by loading
% datasetStart2 ... naiveBayesNeuron can be called here
%% ROC analysis
ROC
%% Now with costs
% just graphical from roc curve

%% combining info from two neurons
load datasetCombine1
muLeft1=mean(neuron1Left);
muRight1=mean(neuron1Right);
stdLeft1=std(neuron1Left);
stdRight1=std(neuron1Right);
muLeft2=mean(neuron2Left);
muRight2=mean(neuron2Right);
stdLeft2=std(neuron2Left);
stdRight2=std(neuron2Right);
pN1gLeft=1/(sqrt(2*pi)*stdLeft1)*exp(-(testSet1-muLeft1).^2/(2*stdLeft1^2));
pN1gRight=1/(sqrt(2*pi)*stdRight1)*exp(-(testSet1-muRight1).^2/(2*stdRight1^2));
pLeft1=pN1gLeft./(pN1gLeft+pN1gRight);  % here we are using Bayes rule
pN2gLeft=1/(sqrt(2*pi)*stdLeft2)*exp(-(testSet2-muLeft2).^2/(2*stdLeft2^2));
pN2gRight=1/(sqrt(2*pi)*stdRight2)*exp(-(testSet2-muRight2).^2/(2*stdRight2^2));
pLeft2=pN2gLeft./(pN2gLeft+pN2gRight);  % here we are using Bayes rule
pLeft=pLeft1.*pLeft2./(pLeft1.*pLeft2+(1-pLeft1).*(1-pLeft2));
plot(pLeft)
hold on
plot(pLeft1,'r')
plot(pLeft2,'g')
hold off

%% Now with real neurons
RealNeuronDecoding

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%% Now on to the modeling of psychophysics %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Bayesian integration with Gaussians
x=-10:0.1:10
muPrior=1;
sigmaPrior=1.5;
prior=exp(-(x-muPrior).^2/(2*sigmaPrior^2));
prior=prior/sum(prior);
plot(x,prior,'g');
muLikelihood=2;
sigmaLikelihood=1;
likelihood=exp(-(x-muLikelihood).^2/(2*sigmaLikelihood^2));
likelihood=likelihood/sum(likelihood);
hold on
plot(x,likelihood,'r');
posterior=prior.*likelihood;
posterior=posterior/(sum(posterior));
plot(x,posterior,'y');
hold off
%% Predict experimental results in psychophysical experiments
predictPsychophysics
%% Causal inference
% this has just a single line of change
feedbacks=-8:.2:8
for i=1:length(feedbacks)
    plot(x,prior,'g');
    muLikelihood=feedbacks(i);
    sigmaLikelihood=1;
    likelihood=exp(-(x-muLikelihood).^2/(2*sigmaLikelihood^2));
    likelihood=likelihood+0.05;
    likelihood=likelihood/sum(likelihood);
    hold on
    plot(x,likelihood,'r');
    posterior=prior.*likelihood;
    posterior=posterior/(sum(posterior));
    meanPosterior(i)=sum(posterior.*x);
    plot(x,posterior,'y');
    hold off
    pause(0.2);
end
plot(feedbacks,meanPosterior)
