%% This script fits the means and the standard deviations to the dataset
%% from one neuron for left movement (neuronLeft) and the same neuron for
%% right movement (neuronRight); It also assumes the existence of a set of
%% activities (testSet) and the predictions for this test-set are analyzed

% calculate means and variances for both directions
muLeft=mean(neuronLeft);
muRight=mean(neuronRight);
stdLeft=std(neuronLeft);
stdRight=std(neuronRight);

%the probability of the neural activity given assumed left movement
pNgLeft=1/(sqrt(2*pi)*stdLeft)*exp(-(testSet-muLeft).^2/(2*stdLeft^2));
%and right movement
pNgRight=1/(sqrt(2*pi)*stdRight)*exp(-(testSet-muRight).^2/(2*stdRight^2));
%Bayes rule combines the two through normalization
pLeft=pNgLeft./(pNgLeft+pNgRight); 
figure(1)
plot(testSet,pLeft,'.');
figure(2)
plot(pLeft);
% do the same thing with a different simulated neurons by loading
% datasetStart2
%% how good
pEq=min(testSet(find(pLeft>.5)));
falseNegative=sum(neuronLeft<pEq)/length(neuronLeft) %switch to test set
falsePositive=sum(neuronRight>pEq)/length(neuronLeft)
