
%% Logistic Regression

% Full fit...
b = glmfit(X,y,'binomial');
yhat = glmval(b,X,'logit');
tre = sum((yhat>0.5)==y)/length(y);

% Leave-one-out Cross-Validation
for j=1:size(X,1)
    loo = [1:(j-1) (j+1):size(X,1)];
    b = glmfit(X(loo,:),y(loo),'binomial');
    yhat(j) = glmval(b,X(j,:),'logit');
end
tse = sum((yhat>0.5)==y)/length(y);

[tre tse]

%% Naive Bayes...

% Full fit
p1 = naiveBayes(X,y,X);
tre = sum((p1>0.5)==y)/length(y);

% Leave-one-out Cross-Validation
for i=1:size(X,1)
    loo = [1:(i-1) (i+1):size(X,1)];
    p1_test(i) = naiveBayes(X(loo,:),y(loo),X(i,:));
end
tse = sum((p1_test>0.5)==y')/length(y);
[tre tse]